 uniform sampler2D _MainTex;
 float4 _Color;
 float _AlphaCutoff;
 float _PivotX;
 float _PivotY;

 struct vertexOut {
    float4 pos : SV_POSITION;
    float4 tex : TEXCOORD0;
    float4 hPos : TEXCOORD1;
 };

 vertexOut VS(float4 position : POSITION,
 					float4 tex : TEXCOORD0) 
 {
    vertexOut output;

    float4x4 MV_I = transpose(UNITY_MATRIX_IT_MV);
    float4x4 VI= mul(_Object2World, MV_I);
    float3 camRight = mul(VI, float4(1,0,0,0)).xyz;
    float3 bbUp = mul(VI, float4(0,1,0,0)).xyz;
    float2 scale = float2(1,1);
    scale.x = length(mul(_Object2World, float4(1,0,0,0)));
    scale.y = length(mul(_Object2World, float4(0,1,0,0)));
    float2 _Pivot = float2(_PivotX,_PivotY);
    float2 offset = (tex.xy - float2(0.5,0.5) - _Pivot) * scale;
  	float4 CenterWPos = mul(_Object2World, float4(_Pivot, 0.0, 1.0));
    float4 WPos = CenterWPos + offset.x*float4(camRight,0) + offset.y*float4(bbUp,0);
    output.pos = mul(UNITY_MATRIX_VP, WPos);
    output.hPos = output.pos;

    output.tex = tex;

    return output;
 }

 float4 PS(vertexOut input) : COLOR
 {
    float4 color = tex2D(_MainTex, float2(input.tex.xy)) * _Color;   
    clip(color.a - _AlphaCutoff);
 #ifdef SHADOW_MAP
    return input.hPos.z / input.hPos.w;
 #else
    return color;
 #endif
 }